<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;

class ItempermintaanbarangModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table="itempermintaanbarang";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable="itempermintaanbarang";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* check the incrementing boolean if the incrementing from database is false then the value is false by default
	*/
	//public $incrementing = false;
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable = [
		"id","itemId","prNumber","needBy","quantity", "date_updated", "harga", "harga_satuan", "sisaawal", "disetujui",
        "qtyRob", "qtyPenggunaan", "portBunker"
	];

	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"id" => "itempermintaanbarang.id",
		"itemId" => "itemId.id",
		"prNumber" => "prNumber.prNumber",
		"needBy" => "itempermintaanbarang.needBy",
		"quantity" => "itempermintaanbarang.quantity",
	];

	/**
	* relation from ' . item . ' by ' . itemId 
	* join item on item.id = itempermintaanbarang.itemId
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationItemId($alias = "itemId")
	{
		$this->getQuery()->join("item as $alias", "$alias.id", "=", "itempermintaanbarang.itemId")
						->join("itemcategory as itemCategory", "itemCategory.id", "=", $alias . ".type_id");
		return $this;
	}
	/**
	* relation from ' . permintaanbarang . ' by ' . prNumber 
	* join permintaanbarang on permintaanbarang.prNumber = itempermintaanbarang.prNumber
	* this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	* but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	* @param string $alias
	* @return $this
	*/
	public function joinRelationPrNumber($alias = "prNumber")
	{
		$this->getQuery()->join("permintaanbarang as $alias", "$alias.prNumber", "=", "itempermintaanbarang.prNumber");
		return $this;
	}

}